import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

public class midlet extends MIDlet implements CommandListener { 
 Command BACK_CMD, SEARCH_CMD;
 private boolean isStarted = false, noMemory = false;
 List main;
 CyrillicWinReader reader;
 public Vector keys, values;
 String s;
 int l=0,pos;

 public midlet() { 
  BACK_CMD = new Command(Settings.BackCommand, Command.BACK, 2);
  SEARCH_CMD = new Command(Settings.SearchCommand, Command.OK, 2);
  reader=new CyrillicWinReader(getClass().getResourceAsStream(Settings.DataBase));
  keys=new Vector();
  values=new Vector ();
  main = new List (Settings.ApplicationHdr, List.IMPLICIT);
  main.append (Settings.SearchCommand, null);
  main.append (Settings.AboutCommand, null);
  main.append (Settings.QuitCommand, null);
  main.setCommandListener (this);
  Display.getDisplay(this).setCurrent(main);
 }

 protected void destroyApp(boolean unconditional) {}

 protected  void pauseApp() {}

 protected void startApp() {
  if (isStarted) { return; }
  try {
   do {
    s=reader.readUTF ();
    if (s!=null) {
     pos=s.indexOf (" - ");
     if (pos>0) {
      try {
       keys.addElement (s.substring (0,pos));
       values.addElement (s.substring(pos+3));
       l++;
      }
      catch (java.lang.OutOfMemoryError mem) {
       l--;
       keys.setSize (l);
       values.setSize (l);
       noMemory = true;
       Runtime.getRuntime().gc();
       break;
      }
     }
     else {
      System.out.println ("\nparse error in line "+(l+1));
      quit ();
     }
    }

    if (l%100==0) { main.setTitle (l+"..."); }
   } while (s != null);
   reader.close();
  }
  catch (IOException x) { }
  main.setTitle (Settings.ApplicationHdr+" ("+l+")");
  if (noMemory == true) {
   new Message (this, main, Settings.ErrorName).show (Settings.NoMemoryStr); 
  }
  isStarted = true;
 }

 public void commandAction(Command c, Displayable d) { 
  if (c==List.SELECT_COMMAND) {
   int selector = main.getSelectedIndex();
   switch (selector) {
    case 0:
     new SearchBox (this, main);  
    break;
    case 1:
     new Message (this, main, Settings.AboutCommand).show (Settings.AboutTxt);
    break;
    case 2:
     quit ();
    break;
   }
  }
 }

 public void quit() { 
  System.gc();
  destroyApp(true);
  notifyDestroyed();
 }

}    
           